/*
 * R̃pgbNȋȐ̃NXKw̃[gƂȂ钊ۃNX
 *
 * Copyright 2000 by Information-technology Promotion Agency, Japan
 * Copyright 2000 by Precision Modeling Laboratory, Inc., Tokyo, Japan
 * Copyright 2000 by Software Research Associates, Inc., Tokyo, Japan
 *
 * $Id: JgclParametricCurve3D.java,v 1.56 2000/08/11 06:18:54 shikano Exp $
 */

package jp.go.ipa.jgcl;

import java.util.Vector;
import java.util.Enumeration;

/**
 * R̃pgbNȋȐ̃NXKw̃[gƂȂ钊ۃNXB
 * <p>
 * ̃NX́A̎lŕ\p[^ t ̒lɂāA
 * ʒu肳R̋Ȑ P(t) Sʂ\B
 * </p>
 *
 * @version $Revision: 1.56 $, $Date: 2000/08/11 06:18:54 $
 * @author Information-technology Promotion Agency, Japan
 * @see JgclParametricCurve2D
 */

public abstract class JgclParametricCurve3D extends JgclParametricCurve {
    /**
     * Ȑ Line ł邱Ƃ萔
     */
    static final int LINE_3D = 1;

    /**
     * Ȑ Bounded Line ł邱Ƃ萔
     */
    static final int BOUNDED_LINE_3D = 2;

    /**
     * Ȑ Circle ł邱Ƃ萔
     */
    static final int CIRCLE_3D = 10;

    /**
     * Ȑ Ellipse ł邱Ƃ萔
     */
    static final int ELLIPSE_3D = 11;

    /**
     * Ȑ Hyperbola ł邱Ƃ萔
     */
    static final int HYPERBOLA_3D = 12;

    /**
     * Ȑ Parabola ł邱Ƃ萔
     */
    static final int PARABOLA_3D = 13;

    /**
     * Ȑ Polyline ł邱Ƃ萔
     */
    static final int POLYLINE_3D = 20;

    /**
     * Ȑ Bspline Curve ł邱Ƃ萔
     */
    static final int BSPLINE_CURVE_3D = 21;

    /**
     * Ȑ Pure Bezier Curve ł邱Ƃ萔
     */
    static final int PURE_BEZIER_CURVE_3D = 22;

    /**
     * Ȑ Trimmed Curve ł邱Ƃ萔
     */
    static final int TRIMMED_CURVE_3D = 23;

    /**
     * Ȑ Composite Curve ł邱Ƃ萔
     */
    static final int COMPOSITE_CURVE_3D = 24;

    /**
     * Ȑ Composite Curve Segment ł邱Ƃ萔
     */
    static final int COMPOSITE_CURVE_SEGMENT_3D = 25;

    /**
     * Ȑ Surface Curve ł邱Ƃ萔
     */
    static final int SURFACE_CURVE_3D = 26;

    /**
     * Ȑ Intersection Curve ł邱Ƃ萔
     */
    static final int INTERSECTION_CURVE_3D = 27;

    /**
     * Ȑ Polynomial Curve ł邱Ƃ萔
     */
    static final int POLYNOMIAL_CURVE_3D = 30;

    /**
     * IuWFNg\zB
     */
    protected JgclParametricCurve3D() {
	super();
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̍WlԂۃ\bhB
     * 
     * @param param	p[^l
     * @return		Wl
     */
    public abstract JgclPoint3D coordinates(double param);

    /**
     * ̋Ȑ́A^ꂽp[^lł̐ڃxNgԂۃ\bhB
     * 
     * @param param	p[^l
     * @return		ڃxNg
     */
    public abstract JgclVector3D tangentVector(double param);

    /**
     * ̋Ȑ́A^ꂽp[^lł̋ȗԂۃ\bhB
     * 
     * @param param	p[^l
     * @return		ȗ
     */
    public abstract JgclCurveCurvature3D curvature(double param);

    /**
     * ̋Ȑ́A^ꂽp[^lł̃CԂۃ\bhB
     * 
     * @param param	p[^l
     * @return		C
     */
    public abstract double torsion(double param);

    /**
     * ̋Ȑ́A^ꂽp[^lł̓֐Ԃۃ\bhB
     * 
     * @param param	p[^l
     * @return		֐
     */
    public abstract JgclCurveDerivative3D evaluation(double param);

    /**
     * ̋Ȑ̓ٓ_Ԃۃ\bhB
     * <p>
     * ٓ_Ƃ́A
     * ڃxNg̑傫 0 ɂȂ_A
     * 邢͂̑OŐڃxNgsAƂȂ_łB
     * </p>
     * <p>
     * ٓ_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @return		ٓ_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public abstract JgclPointOnCurve3D[] singular() throws JgclIndefiniteSolution;

    /**
     * ̋Ȑ̕ϋȓ_Ԃۃ\bhB
     * <p>
     * ϋȓ_Ƃ́ȂOŋȗS݂̑TChړ_łB
     * </p>
     * <p>
     * ϋȓ_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @return		ϋȓ_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public abstract JgclPointOnCurve3D[] inflexion() throws JgclIndefiniteSolution;

    /**
     * ^ꂽp[^l̓_A
     * _̋Ȑɓe_ (܂A_炱̋Ȑւ̐̑) 
     * 邩ǂԂB
     * <p>
     * ^ꂽp[^l̓_e_ł΁A̓_\_ԂB
     * ^ꂽp[^l̓_e_łȂ null ԂB
     * </p>
     * 
     * @param Bparam	e_̃p[^l
     * @param p		e̓_
     * @param dTol2	̋e덷̎
     * @return		e_IuWFNg
     * @see	#projectFrom(JgclPoint3D)
     */
    protected JgclPointOnCurve3D checkProjection(double Bparam,
						 JgclPoint3D p,
						 double dTol2)
    {
	JgclPointOnCurve3D result = null;

	if (!isValid(Bparam)) {
	    return null;
	}

	JgclPoint3D Bpnt = coordinates(Bparam);
	JgclVector3D Bpnt2A = p.subtract(Bpnt);
	double norm = Bpnt2A.norm();

	if (norm > dTol2) {
	    JgclCurveCurvature3D Bcurv = curvature(Bparam);
	    double norm_from_Bnrml = Bpnt2A.crossProduct(Bcurv.normal()).norm();
	    if (norm_from_Bnrml > dTol2) {
		return null;
	    }
	}

	try {
	    return new JgclPointOnCurve3D(Bpnt, this, Bparam, doCheckDebug);
	}
	catch (JgclInvalidArgumentValue e) {
	    throw new JgclFatal();
	}
    }

    /**
     * ^ꂽ̃p[^l̋Ȑœ̓_Ƃ݂Ȃ邩ǂԂB
     * <p>
     * ̃p[^l̊Ԃ̋Ȑ̓̂肪A
     * ݐݒ肳Ă鉉Z̋̋e덷
     * ̃p[^l͓̓_\Ă̂ƂB
     * </p>
     * 
     * @param own_prm1	p[^l 1
     * @param own_prm2	p[^l 2
     * @return		̓_Ƃ݂ȂȂ trueAłȂ false
     */
    public boolean identicalParameter(double own_prm1, double own_prm2) {
	JgclPoint3D o1_crd, o2_crd;
	JgclParameterDomain pdmn;
	JgclParameterSection pint;
	double leng;

	checkValidity(own_prm1);
	checkValidity(own_prm2);

	o1_crd = coordinates(own_prm1);
	o2_crd = coordinates(own_prm2);

	if (!o1_crd.identical(o2_crd))
	    return false;

	pdmn = parameterDomain();

	double pTol;
	double increase = 0.0;
	if (pdmn.isInfinite())
	    pTol = JgclMachineEpsilon.DOUBLE;
	else {
	    increase = Math.abs(pdmn.section().increase());
	    if (increase < 1.0)
		pTol = JgclMachineEpsilon.DOUBLE * increase;
	    else
		pTol = JgclMachineEpsilon.DOUBLE;
	}

	JgclConditionOfOperation condition =
	    JgclConditionOfOperation.getCondition();
	double savedPTol = condition.getToleranceForParameter();

	condition.makeCopyWithToleranceForParameter(pTol).push();
	try {

	    if (own_prm1 > own_prm2)
		pint = new JgclParameterSection(own_prm2, own_prm1 - own_prm2);
	    else
		pint = new JgclParameterSection(own_prm1, own_prm2 - own_prm1);

	    leng = length(pint);

	    double dTol = condition.getToleranceForDistance();
	    if (leng < dTol)
		return true;

	    if (!pdmn.isPeriodic())
		return false;
	    else {
		double start = (own_prm1 > own_prm2) ? own_prm1 : own_prm2;
		increase = increase - pint.increase();
		pint = new JgclParameterSection(start, increase);
		leng = length(pint);

		if (leng < dTol)
		    return true;
	    }
	    return false;
	}
	finally {
	    JgclConditionOfOperation.pop();
	}
    }

    /**
     * ^ꂽ_炱̋Ȑւ̓e_߂钊ۃ\bhB
     * <p>
     * e_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param point	e̓_
     * @return		e_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public abstract JgclPointOnCurve3D[] projectFrom(JgclPoint3D point)
	throws JgclIndefiniteSolution;

    /**
     * ̋Ȑ̎w̋ԂA^ꂽ덷Œߎ|CԂۃ\bhB
     * <p>
     * ʂƂĕԂ|C\_ JgclPointOnCurve3D 
     * 邱Ƃ҂łB
     * </p>
     * 
     * @param pint	ߎp[^
     * @param tol	̋e덷
     * @return		̋Ȑ̎w̋Ԃ𒼐ߎ|C
     * @see		JgclPointOnCurve3D
     */
    public abstract JgclPolyline3D
	toPolyline(JgclParameterSection pint, JgclToleranceForDistance tol);

    /**
     * ̋Ȑ̎w̋ԂɍČL Bspline ȐԂۃ\bhB
     * 
     * @param pint	L Bspline ȐōČp[^
     * @return		̋Ȑ̎w̋ԂČL Bspline Ȑ
     */
    public abstract JgclBsplineCurve3D
	toBsplineCurve(JgclParameterSection pint);

    /**
     * ̋ȐƑ̋Ȑ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public abstract JgclIntersectionPoint3D[]
	intersect(JgclParametricCurve3D mate)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ () ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ ()
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclLine3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (~) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (~)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclCircle3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (ȉ~) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (ȉ~)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclEllipse3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (oȐ) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (oȐ)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclHyperbola3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ () ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ ()
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclParabola3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (|C) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (|C)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclPolyline3D mate, boolean doExchange)
	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (xWGȐ) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (xWGȐ)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclPureBezierCurve3D mate, boolean doExchange)
	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (aXvCȐ) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (aXvCȐ)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclBsplineCurve3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (gȐ) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (gȐ)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclTrimmedCurve3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (ȐZOg) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (ȐZOg)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclCompositeCurveSegment3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȑ (Ȑ) ̌_߂钊ۃ\bh (internal use) B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȑ (Ȑ)
     * @param doExchange	_ pointOnCurve1/2 邩ǂ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
	intersect(JgclCompositeCurve3D mate, boolean doExchange)
	 throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȗʂ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public abstract JgclIntersectionPoint3D[]
  	intersect(JgclParametricSurface3D mate)
    	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȗ (͓IȖ) ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (͓IȖ)
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
    	intersect(JgclElementarySurface3D mate, boolean doExchange)
      	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȗ (xWGȖ) ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (xWGȖ)
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
  	intersect(JgclPureBezierSurface3D mate, boolean doExchange)
    	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȗ (aXvCȖ) ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (aXvCȖ)
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    abstract JgclIntersectionPoint3D[]
  	intersect(JgclBsplineSurface3D mate, boolean doExchange)
    	throws JgclIndefiniteSolution;

    /**
     * ̋ȐƑ̋Ȗ (ȐEȖ) ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (ȐEȖ)
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    JgclIntersectionPoint3D[]
  	intersect(JgclCurveBoundedSurface3D mate, boolean doExchange)
    	throws JgclIndefiniteSolution
    {
	return mate.intersect(this, !doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗ (`gȖ) ̌_߂钊ۃ\bhB
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (`gȖ)
     * @return		_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    JgclIntersectionPoint3D[]
  	intersect(JgclRectangularTrimmedSurface3D mate, boolean doExchange)
    	throws JgclIndefiniteSolution
    {
	return mate.intersect(this, !doExchange);
    }
    
    /**
     * ̋ȐA^ꂽxNgɏ]ĕsړȐԂۃ\bhB
     *
     * @param moveVec	sړ̕Ɨʂ\xNg
     * @return		sړ̋Ȑ
     */
    public abstract JgclParametricCurve3D
	parallelTranslate(JgclVector3D moveVec);

    /**
     * ̋Ȑ̎ԂB
     * <p>
     *  3 ԂB
     * </p>
     *
     * @return RȂ̂ŁA 3
     */
    public int dimension() {
	return 3;
    }

    /**
     * ̋ȐRۂԂB
     * <p>
     *  true ԂB
     * </p>
     * 
     * @return		RȂ̂ŁA true
     */
    public boolean is3D() {
	return true;
    }

    /**
     * ̋Ȑ̗vfʂԂۃ\bhB
     *
     * @return	vf
     * @see #LINE_3D
     * @see #BOUNDED_LINE_3D
     * @see #CIRCLE_3D
     * @see #ELLIPSE_3D
     * @see #HYPERBOLA_3D
     * @see #PARABOLA_3D
     * @see #POLYLINE_3D
     * @see #BSPLINE_CURVE_3D
     * @see #PURE_BEZIER_CURVE_3D
     * @see #TRIMMED_CURVE_3D
     * @see #COMPOSITE_CURVE_3D
     * @see #COMPOSITE_CURVE_SEGMENT_3D
     * @see #SURFACE_CURVE_3D
     * @see #INTERSECTION_CURVE_3D
     * @see #POLYNOMIAL_CURVE_3D
     */
    abstract int type();

    /**
     * ̋ȐA^ꂽǏWn Z ̎ɁA
     * ^ꂽpx]ȐԂۃ\bhB
     *
     * @param trns	ǏWn瓾ꂽWϊZq
     * @param rCos	cos(]px)
     * @param rSin	sin(]px)
     * @return		]̋Ȑ
     */
    abstract JgclParametricCurve3D rotateZ(JgclCartesianTransformationOperator3D trns,
					   double rCos,
					   double rSin);

    /**
     * ̋Ȑ̓_ŁA^ꂽɂȂ_ԂB
     *
     * @param line	
     * @return		^ꂽɂȂ_
     */
    abstract JgclPoint3D getPointNotOnLine(JgclLine3D line);

    /**
     * ^ꂽ_ P 炱̋Ȑւ̓e_̓ŁAP ɍł߂_ԂB
     * <p>
     * e_݂Ȃꍇɂ null ԂB
     * </p>
     * 
     * @param pnt	e̓_
     * @return		e̓_ɍł߂e_
     * @see	#projectFrom(JgclPoint3D)
     * @see	#nearestProjectWithDistanceFrom(JgclPoint3D, double)
     */
    public JgclPointOnCurve3D nearestProjectFrom(JgclPoint3D pnt) {
	JgclPointOnCurve3D[] proj;
	try {
	    proj = projectFrom(pnt);
	}
	catch (JgclIndefiniteSolution e) {
	    proj = new JgclPointOnCurve3D[1];
	    proj[0] = (JgclPointOnCurve3D)e.suitable();
	}

	if (proj.length == 0)
	    return null;

	double dist = proj[0].distance2(pnt);
	int idx = 0;

	// find nearest point
	for (int i = 1; i < proj.length; i++) {
	    double dist2 = proj[i].distance2(pnt);

	    if (dist2 < dist) {
		dist = dist2;
		idx = i;
	    }
	}

	return proj[idx];
    }

    /**
     * ^ꂽ_ P 炱̋Ȑւ̓e_̓ŁAP ̋w̒lɍł߂_ԂB
     * <p>
     * e_݂Ȃꍇɂ null ԂB
     * </p>
     * 
     * @param pnt	e̓_
     * @param distance	
     * @return		w肵ɍł߂e_
     * @see	#projectFrom(JgclPoint3D)
     * @see	#nearestProjectFrom(JgclPoint3D)
     */
    public JgclPointOnCurve3D nearestProjectWithDistanceFrom(JgclPoint3D pnt, double distance) {
	JgclPointOnCurve3D[] proj;
	try {
	    proj = projectFrom(pnt);
	}
	catch (JgclIndefiniteSolution e) {
	    proj = new JgclPointOnCurve3D[1];
	    proj[0] = (JgclPointOnCurve3D)e.suitable();
	}

	if (proj.length == 0)
	    return null;

	double diff = Math.abs(distance - proj[0].distance(pnt));
	int idx = 0;

	// find nearest point
	for (int i = 1; i < proj.length; i++) {
	    double diff2 = Math.abs(distance - proj[i].distance(pnt));

	    if (diff2 < diff) {
		diff = diff2;
		idx = i;
	    }
	}

	return proj[idx];
    }

    /**
     * ^ꂽ_́A̋Ȑł̃p[^l߂B
     * <p>
     * ^ꂽ_̋ȐɏĂ̂ƂāA
     * ̓_ɑΉp[^l߂B
     * </p>
     * <p>
     * ̃\bh͈̓ȉ̒ʂB
     * <ul>
     * <li> nearestProjectFrom(pnt) gāA
     *		^ꂽ_ P ɍł߂e_ Q 𓾂
     * <li> Q ݂āA
     *		P  Q ݐݒ肳Ă鉉Zœ̓_Ƃ݂Ȃ΁A
     *		Q ̃p[^lԂ
     * <li> ̋ȐLŊJȐŁA
     *		[_ P ɈvȂ΁Ãp[^lԂ
     * <li> ̋Ȑ|C̕Ȃ΁A|CɕϊA
     *		̃|C̒_ P ƈv̂΁A
     *		̃p[^lԂ
     * <li> ȏ̂ɂĂ͂܂Ȃ΁AJgclInvalidArgumentValue 𓊂
     * </ul>
     * </p>
     *
     * @param pnt	Ȑ̓_
     * @return		Ήp[^l
     * @see	JgclInvalidArgumentValue
     * @see	#nearestProjectFrom(JgclPoint3D)
     * @see	JgclConditionOfOperation
     */
    public double pointToParameter(JgclPoint3D pnt) {
	// e_ identical H
	JgclPointOnCurve3D proj = nearestProjectFrom(pnt);
	if ((proj != null) && (pnt.identical(proj)))
	    return proj.parameter();

	// [_ꍇA炪 identical H
	if (this.isFinite() && this.isOpen()) {
	    double param;

	    param = this.parameterDomain().section().lower();
	    if (pnt.identical(new JgclPointOnCurve3D(this, param)))
		return param;

	    param = this.parameterDomain().section().upper();
	    if (pnt.identical(new JgclPointOnCurve3D(this, param)))
		return param;
	}

	// |C̉ӏꍇAidentical Ȓ_邩H
	if (this.hasPolyline() == true) {
	    JgclBoundedCurve3D bounded = (JgclBoundedCurve3D)this;
	    JgclPolyline3D polyline = bounded.toPolyline(getToleranceForDistanceAsObject());
	    JgclPointOnCurve3D pos;

	    for (int i = 0; i < polyline.nPoints(); i++) {
		pos = (JgclPointOnCurve3D)polyline.pointAt(i);
		if (pnt.identical(pos))
		    return pos.parameter();
	    }
	}

	throw new JgclInvalidArgumentValue();
    }

    /**
     * ^ꂽp[^l̂̋Ȑɑ΂鐳𒲂ׂB
     * <p>
     * <ul>
     * <li> ^ꂽp[^l P A̋Ȑ̒` ([_܂) ɂ
     *		JgclParameterValidity.PROPERLY_INSIDE ԂB
     * <li> ł͂ȂAP ̋Ȑ̒`扺菬A
     *		̍ԏł̋ɒul
     *		ݐݒ肳Ă鉉Z
     *		̋e덷ꍇɂ
     *		JgclParameterValidity.TOLERATED_LOWER_LIMIT ԂB
     * <li> ł͂ȂAP ̋Ȑ̒`傫A
     *		̍ԏł̋ɒul
     *		ݐݒ肳Ă鉉Z
     *		̋e덷ꍇɂ
     *		JgclParameterValidity.TOLERATED_UPPER_LIMIT ԂB
     * <li> ̂łȂ΁A
     *		JgclParameterValidity.OUTSIDE ԂB
     * <ul>
     * </p>
     *
     * @param  param   p[^l
     * @return         p[^l̂̋Ȑɑ΂鐳
     * @see	JgclParameterValidity
     */
    int parameterValidity(double param) {
	JgclParameterDomain pDomain = this.parameterDomain();

	if (pDomain.isInfinite() || pDomain.isPeriodic())
	    return JgclParameterValidity.PROPERLY_INSIDE;

	double lower = pDomain.section().lower();
	double upper = pDomain.section().upper();
	double deltaDenom = 100;
	double delta = (upper - lower) / deltaDenom;
	double tol4Norm = this.getToleranceForDistance2();
	double endParam;
	JgclVector3D tangentVector;
	double tangentNorm = 0.0;
	double tol4Param;

	if (param < lower) {
	    endParam = lower;
	    while (endParam < upper) {
		tangentVector = this.tangentVector(endParam);
		if ((tangentNorm = tangentVector.norm()) > tol4Norm)
		    break;
		endParam += delta;
	    }
	    if (!(tangentNorm > tol4Norm))
		return JgclParameterValidity.OUTSIDE;

	    tol4Param = this.getToleranceForDistance() / Math.sqrt(tangentNorm);
	    if ((lower - param) < tol4Param)
		return JgclParameterValidity.TOLERATED_LOWER_LIMIT;
	    else
		return JgclParameterValidity.OUTSIDE;
	}

	if (upper < param) {
	    endParam = upper;
	    while (endParam > lower) {
		tangentVector = this.tangentVector(endParam);
		if ((tangentNorm = tangentVector.norm()) > tol4Norm)
		    break;
		endParam -= delta;
	    }
	    if (!(tangentNorm > tol4Norm))
		return JgclParameterValidity.OUTSIDE;

	    tol4Param = this.getToleranceForDistance() / Math.sqrt(tangentNorm);
	    if ((param - upper) < tol4Param)
		return JgclParameterValidity.TOLERATED_UPPER_LIMIT;
	    else
		return JgclParameterValidity.OUTSIDE;
	}

	return JgclParameterValidity.PROPERLY_INSIDE;
    }

    /**
     * ̋ȐA^ꂽ􉽓IϊZqŕϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŕϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŕϊ̂ԂB
     * </p>
     *
     * @param reverseTransform		tϊ̂ł trueAłȂ false
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	ϊ̊􉽗vf
     */
    protected abstract JgclParametricCurve3D
    doTransformBy(boolean reverseTransform,
		  JgclCartesianTransformationOperator3D transformationOperator,
		  java.util.Hashtable transformedGeometries);

    /**
     * ̋ȐA^ꂽ􉽓IϊZqŕϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŕϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŕϊ̂ԂB
     * </p>
     *
     * @param reverseTransform		tϊ̂ł trueAłȂ false
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	ϊ̊􉽗vf
     */
    public synchronized JgclParametricCurve3D
    transformBy(boolean reverseTransform,
		JgclCartesianTransformationOperator3D transformationOperator,
		java.util.Hashtable transformedGeometries)
    {
	if (transformedGeometries == null)
	    return this.doTransformBy(reverseTransform,
				      transformationOperator,
				      transformedGeometries);

	JgclParametricCurve3D transformed = (JgclParametricCurve3D)transformedGeometries.get(this);
	if (transformed == null) {
	    transformed = this.doTransformBy(reverseTransform,
					     transformationOperator,
					     transformedGeometries);
	    transformedGeometries.put(this, transformed);
	}
	return transformed;
    }

    /**
     * ̋ȐA^ꂽ􉽓IϊZqŕϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŕϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŕϊ̂ԂB
     * </p>
     *
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	ϊ̊􉽗vf
     */
    public synchronized JgclParametricCurve3D
    transformBy(JgclCartesianTransformationOperator3D transformationOperator,
		java.util.Hashtable transformedGeometries)
    {
	return transformBy(false, transformationOperator, transformedGeometries);
    }

    /**
     * ̋ȐA^ꂽ􉽓IϊZqŋtϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŋtϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŋtϊ̂ԂB
     * </p>
     *
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	tϊ̊􉽗vf
     */
    public synchronized JgclParametricCurve3D
    reverseTransformBy(JgclCartesianTransformationOperator3D transformationOperator,
		       java.util.Hashtable transformedGeometries)
    {
	return transformBy(true, transformationOperator, transformedGeometries);
    }

    /**
     * ̋Ȑ|C̕܂ނۂԂB
     * <p>
     * ʂ true ̏ꍇA
     * ̋Ȑ {@link JgclBoundedCurve3D JgclBoundedCurve3D} ł͂łB
     * </p>
     *
     * @return	̋Ȑ|Cł邩A
     *		܂͎g\镔iƂă|C܂ނȂ trueA
     *		łȂ false
     */
    protected boolean hasPolyline() {
	return false;
    }

    /**
     * ̋Ȑ|C̕łłĂ邩ۂԂB
     * <p>
     * ʂ true ̏ꍇA
     * ̋Ȑ {@link JgclBoundedCurve3D JgclBoundedCurve3D} ł͂łB
     * </p>
     *
     * @return	̋Ȑ|Cł邩A
     *		܂͎g\镔iƂă|C܂ނȂ trueA
     *		łȂ false
     */
    protected boolean isComposedOfOnlyPolylines() {
	return false;
    }

}

